/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
//-----------------------------------------------------------------------------
//警告定義
enum {
	WARN_CAST,			//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
};
static const char* const warn_tokens[]={
	"cast",				//暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。このオプションを指定しなければ、警告表示もエラー終了もしません。
NULL};//終端
int warn;				//各警告(WARN_*)について(warn&(1<<WARN_*))がセットされていたらその警告がOnである事を示します。
/*---------------------------------------------------------------------------*/
//ローカル変数定義
static ght_hash_table_t* ht_anm;	//アニメーション名⇒(ST_Anm*)
//ラベル名のソート方法
int (*fnLabCmp)(const void*, const void*) = strcmp;	//'n'オプションが指定されたらstrnatcmpに変更する。
//{{進捗表示用
static int opt_q;
static int newMsgLen, oldMsgLen = 0;
//}}進捗表示用
static int nTotalWordSize;	//全アニメーションデータワードサイズの合計
/*---------------------------------------------------------------------------*/
//エラーログ用
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
typedef struct _ST_Location {
	const char*	path;					//push_location()が呼び出された直前のファイル名
	int		line;					//push_location()が呼び出された直前の行番号
} ST_Location;
static ST_Location TBL_Location[16/*調整可*/];			//ロケーションスタック
static nLocation;						//ロケーションスタックの格納数
static const char* filename = "-";				//現在のファイル名(popen時はコマンド名)。現在の行番号はyylinenoを参照して下さい。
static void init_location(const char* path) {
	nLocation = 0;						//ロケーションスタックを空にする。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。	yylex_init()でも初期化しているのでこの行は無くても構わないのだが、判り易さのためにここでも初期化する事にした。
}
void push_location(const char* path) {
	if(nLocation >= ARRAY_SIZE(TBL_Location)) { DIE(); }	//ロケーションスタックがフルでない事を確認する。
	TBL_Location[nLocation].path = filename;		//現在のファイル名をロケーションスタックに退避する。
	TBL_Location[nLocation].line = yylineno;		//現在の行番号をロケーションスタックに退避する。
	nLocation++;						//ロケーションスタックの格納数を増やす。
	filename = strdup(path);				//現在のファイル名をコピーして保持する。
	yylineno = 1;						//現在の行番号を初期化する。
}
void pop_location() {
	if(!nLocation) { DIE(); }				//ロケーションスタックが空でない事を確認する。
	nLocation--;						//ロケーションスタックの格納数を減らす。
	filename = TBL_Location[nLocation].path;		//現在のファイル名をロケーションスタックから復元する。
	yylineno = TBL_Location[nLocation].line;		//現在の行番号をロケーションスタックから復元する。
}
//}}2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { error(EXIT_FAILURE, errno, "%s が作成できません。", err_path); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
//{{2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
//	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
//	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
//↓2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	             fprintf(stderr, "%s(%d) : ", filename, yylineno);		//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "%s(%d) : ", filename, yylineno); }	//エラーログ
//}}2016/09/24変更:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/*---------------------------------------------------------------------------*/
//ローカル関数宣言
__declspec(noreturn) static void usage();
static int subr(int argc, char* argv[]);
static void pass2(int bOptimize);
static void optimize();
static void output(char* sBinOut);
/*---------------------------------------------------------------------------*/
int main(int argc, char* argv[]) {
	int exitCode;
	SEH_init();
	exitCode = subr(argc, argv);
	return exitCode;
}
/*---------------------------------------------------------------------------*/
static int subr(int argc, char* argv[]) {
	int opt, bOptimize = 1;	//'-d'オプションが指定されなければ最適化を行う。
	char* sBinOut = NULL;	//'-o'オプションが指定されたらバイナリ出力ファイル名を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; //nonzero means print parse trace
#endif/*(YYDEBUG!=0)*/
	//コマンドラインオプションを処理する。
	opterr = 0; //オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。
	while((opt = getopt(argc, argv, "do:enw::qh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;		//最適化を行わない。
			break;
		case 'o':
			sBinOut = optarg;	//バイナリ出力ファイル名を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'n':
			fnLabCmp = strnatcmp;	//ラベル名のソートにstrnatcmp()を使用する。
			break;
		case 'w':
			if(optarg) {
				char *optionp = optarg, *valuep;
				while(*optionp) {
					switch(getsubopt(&optionp, (char* const*)warn_tokens, &valuep)) {
					case WARN_CAST:
						if(valuep) { usage(); }
						warn |= (1<<WARN_CAST);
						break;
					default:
						usage();
					}
				}
			} else {
				warn = -1;
			}
			break;
		case 'q':
			opt_q = 1;
			break;
		case 'h':
		default:
			usage();
		}
	}
	//ハッシュテーブルを作成する。
	ght_set_rehash((ht_anm = ght_create(0)), 1);
	//--- 1パス目の処理 ---
	//ファイルが指定されていなければ、標準入力から読み込む。
	if(optind == argc) {
		init_location("-");	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
		yylex_init(stdin);
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	//ファイルが指定されていたら、各ファイルを読み込む。
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { error(EXIT_FAILURE, errno, "%s が開けません。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
			init_location(argv[i]);	//{{2016/09/24追加:エラーメッセージに、現在の行番号だけでなく、現在のファイル名も表示するようにしました。}}
			yylex_init(fp);
//{{2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
//			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
//↓2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
			{
				int save_yynerrs = yynerrs;	//yyparse()がyynerrsをクリアするので、その前に現在のyynerrsを保存しておく。
				if((yyparse() != 0) /*|| (yynerrs != 0)*/) { error(EXIT_FAILURE, 0, "%s: エラーが発生しました。", argv[i]); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
				yynerrs += save_yynerrs;	//今回のyyparse()が0から数えたであろうyynerrsに対して、先ほど保存しておいたyynerrsを足し込む。
			}
//}}2017/03/16変更:複数の入力ファイルを指定した時に、最後以外のファイルでエラーが発生した場合、当ツールの終了ステータスが0になっていたバグを修正しました。
			fclose(fp);
		}
	}
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass1 ok");
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
	}
    //}}進捗表示用
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	//2パス目の処理を行う。
	pass2(bOptimize);
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass2 ok");
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } putc('\n', stderr); oldMsgLen = 0;
	}
    //}}進捗表示用
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	//--- 出力処理 ---
	//出力処理を行う。
	output(sBinOut);
	if(yynerrs != 0) { error(EXIT_FAILURE, 0, "エラーが発生しました。"); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
//使い方を表示して終了する。
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dAnmSeqC - ステートレスアニメーションシーケンサコンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2016-2017 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dAnmSeqC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d           最適化を行いません。\n");
	fprintf(stderr, "               このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -oファイル名 アニメーションのバイナリデータを、バイナリ形式でファイルへ出力します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、Cソース形式で標準出力へ出力します。\n");
	fprintf(stderr, "               このオプションの指定に関らず、ラベルは常に標準出力へ出力します。\n");
	fprintf(stderr, "  -e           エラーログファイルを生成します。\n");
	fprintf(stderr, "               このオプションを指定しても、エラーが発生しなければ生成されません。\n");
	fprintf(stderr, "  -n           ラベル名のソートに、strnatcmp()を使用します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、strcmp()を使用します。\n");
	fprintf(stderr, "  -w           全ての警告を有効にします。\n");
	fprintf(stderr, "               このオプションを指定しなければ、個別に設定した警告のみが有効になります。\n");
	fprintf(stderr, "  -wcast       暗黙の型変換で誤差が生じたら、警告を表示し最終的にエラー終了します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、警告表示もエラー終了もしません。\n");
	fprintf(stderr, "  -q           進捗表示を抑制します。\n");
	fprintf(stderr, "  -h           使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  ①dAnmSeqC.exe AnmSeq.txt > AnmSeq.c\n");
	fprintf(stderr, "  　AnmSeq.txtをコンパイルして、AnmSeq.cへ出力します。\n");
	fprintf(stderr, "  ②dAnmSeqC.exe -oAnmSeq.bin AnmSeq.txt > AnmSeq.h\n");
	fprintf(stderr, "  　AnmSeq.txtをコンパイルして、ラベルをAnmSeq.hへ出力します。\n");
	fprintf(stderr, "  　アニメーションのバイナリデータを、AnmSeq.binへ出力します。\n");
	exit(EXIT_FAILURE);
}
/*---------------------------------------------------------------------------*/
//1パス目の処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
int cast_dbl_to_int(double d) {
	int i = d;
	if(i != d) {
		if(warn & (1<<WARN_CAST)) {
			yyerror("切り捨て誤差が発生しました: %f → %d", d, i);
			yynerrs++;	//呼び出し元(main)に知らせるために。
			//全てのセマンティクスエラーを報告するために継続する。
		}
	}
	return i;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void addAnm(ST_Anm* pAnm) {
    //{{進捗表示用
	if(!opt_q) {
		newMsgLen = fprintf(stderr, "\rpass1 %s", pAnm->pAnmLab);
		if(oldMsgLen > newMsgLen) { fprintf(stderr, "%*s", oldMsgLen - newMsgLen, ""); } oldMsgLen = newMsgLen;
	}
    //}}進捗表示用
	//ラベルが重複していない事を確認し、アニメーションを登録する。
	if(ght_insert(ht_anm,
		       pAnm,
		strlen(pAnm->pAnmLab) + 1/*nul*/,
		       pAnm->pAnmLab)) {
		yyerror("ラベルが重複しています。(%s)", pAnm->pAnmLab);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		return;		//全てのセマンティクスエラーを報告するために継続する。
	}
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_Anm* Anm_New(char* pAnmLab, ST_KeyRows* pKeyRowsI/*NULL可*/, ST_KeyRows* pKeyRowsL/*NULL可*/, int bStay) {	//pKeyRowsIとpKeyRowsLは、両方とも非NULLか,又は,片方だけNULL可。両方ともNULLは不可。この制約は、y.tab.yのルールで保障されるので、当関数の処理で検査する必要は無い。
	ST_Anm* pAnm = calloc(1, sizeof(ST_Anm));
	if(!pAnm) { DIE(); }
	pAnm->pAnmLab		= pAnmLab;
	//キーフレームリスト(イントロ部分)が有れば…
	if(pKeyRowsI) {
		int iKeyRow;
		for(iKeyRow = 0; iKeyRow < pKeyRowsI->nKeyRow; iKeyRow++) {
			ST_KeyRow* pKeyRow = pKeyRowsI->aKeyRow[iKeyRow];
		    //{{隣り合ったキーフレームの値が同じならば、先行するキーフレームに時間を合算して、キーフレームの総数を減らす最適化処理。
			if(pAnm->pKeyRows) {						//前のキーフレームが有り…
				ST_KeyRow* pPrevRow = pAnm->pKeyRows->aKeyRow[pAnm->pKeyRows->nKeyRow - 1];
				if(pPrevRow->iSprNo == pKeyRow->iSprNo) {		//前のキーフレームと、今回追加しようとしているキーフレームの、値が同じならば…
					pPrevRow->nFrame	+= pKeyRow->nFrame;	//前のキーフレームのフレーム数に、今回追加しようとしていたキーフレームの、フレーム数を加算する。	ここで(nFrame>UINT16_MAX)になる可能性も有るが、最終的に(tEnd>UINT16_MAX)で検出出来るので、ここで検出しなくても問題無い。
					pAnm->tEnd		+= pKeyRow->nFrame;	//(最終時刻+1)を進める。
					continue;					//前のキーフレームに統合したので、このキーフレームは追加しない。
				}
			}
		    //}}隣り合ったキーフレームの値が同じならば、先行するキーフレームに時間を合算して、キーフレームの総数を減らす最適化処理。
			pKeyRow->tKey	= pAnm->tEnd;					//このキーの時刻を格納する。
			pAnm->tEnd	+= pKeyRow->nFrame;				//(最終時刻+1)を進める。
			pAnm->pKeyRows	= KeyRows_Add(pAnm->pKeyRows, pKeyRow);		//キーフレームリストに、このキーフレームを追加する。
			if(!pAnm->pKeyRows) { return NULL; }				//KeyRows_Add()がエラーを返したら、y.tab.yの処理でYYERRORを行う。
		}
	}
	pAnm->tRep	= pAnm->tEnd;							//ループ戻り時刻を格納する。
	//キーフレームリスト(ループ部分)が有れば…
	if(pKeyRowsL) {
		int iKeyRow;
		for(iKeyRow = 0; iKeyRow < pKeyRowsL->nKeyRow; iKeyRow++) {
			ST_KeyRow* pKeyRow = pKeyRowsL->aKeyRow[iKeyRow];
		    //{{隣り合ったキーフレームの値が同じならば、先行するキーフレームに時間を合算して、キーフレームの総数を減らす最適化処理。
			if(pAnm->pKeyRows) {						//前のキーフレームが有り…
				ST_KeyRow* pPrevRow = pAnm->pKeyRows->aKeyRow[pAnm->pKeyRows->nKeyRow - 1];
				if(pPrevRow->iSprNo == pKeyRow->iSprNo) {		//前のキーフレームと、今回追加しようとしているキーフレームの、値が同じならば…
					pPrevRow->nFrame	+= pKeyRow->nFrame;	//前のキーフレームのフレーム数に、今回追加しようとしていたキーフレームの、フレーム数を加算する。	ここで(nFrame>UINT16_MAX)になる可能性も有るが、最終的に(tEnd>UINT16_MAX)で検出出来るので、ここで検出しなくても問題無い。
					pAnm->tEnd		+= pKeyRow->nFrame;	//(最終時刻+1)を進める。
					continue;					//前のキーフレームに統合したので、このキーフレームは追加しない。
				}
			}
		    //}}隣り合ったキーフレームの値が同じならば、先行するキーフレームに時間を合算して、キーフレームの総数を減らす最適化処理。
			pKeyRow->tKey	= pAnm->tEnd;					//このキーの時刻を格納する。
			pAnm->tEnd	+= pKeyRow->nFrame;				//(最終時刻+1)を進める。
			pAnm->pKeyRows	= KeyRows_Add(pAnm->pKeyRows, pKeyRow);		//キーフレームリストに、このキーフレームを追加する。
			if(!pAnm->pKeyRows) { return NULL; }				//KeyRows_Add()がエラーを返したら、y.tab.yの処理でYYERRORを行う。
		}
	}
//不要	pAnm->tEnd	= (最終時刻+1);							//ここまでの処理で既に、(pAnm->tEnd=(最終時刻+1))になっているので、明示的な格納処理は不要です。もしキーフレームリスト(ループ部分)が無ければ、pAnm->tEndは進んでいないので、(pAnm->tRep==pAnm->tEnd)になっていて、ループ無しを示します。
	if((unsigned)pAnm->tEnd > UINT16_MAX) {
		yyerror("(最終時刻+1)が制限を超えました。(%s)", pAnmLab);
		DIE();	//継続しても無駄なので終了する。
	}
	//ステイフラグが指定されていたら、ループ戻り時刻を((最終時刻+1)-1)で上書きする。
	if(bStay) { pAnm->tRep = (pAnm->tEnd - 1); }
	return pAnm;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_KeyRows* KeyRows_Add(ST_KeyRows* pKeyRows/*NULL可*/, ST_KeyRow* pKeyRow) {
	if(!pKeyRows) {
		pKeyRows = calloc(1, sizeof(ST_KeyRows));
		if(!pKeyRows) { DIE(); }
	}
	if((unsigned)(pKeyRows->nKeyRow + 1) > (UINT16_MAX + 1)) {			//出力時に(-1)するので、上限は(UINT16_MAX+1)である。詳細は、pass2()内の「アニメーションデータを作成する」の処理を参照せよ。
		yyerror("キーフレーム数が多過ぎます。(%d)", (pKeyRows->nKeyRow + 1));
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return NULL;	//y.tab.yの処理でYYERRORを行う。
	}
	pKeyRows = realloc(pKeyRows,
		sizeof(ST_KeyRows) +
		(sizeof pKeyRows->aKeyRow[0]) * (pKeyRows->nKeyRow + 1));
	if(!pKeyRows) { DIE(); }
	pKeyRows->aKeyRow[pKeyRows->nKeyRow++]	= pKeyRow;
	return pKeyRows;
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
ST_KeyRow* KeyRow_New(int iSprNo, int nFrame) {
	ST_KeyRow* pKeyRow = calloc(1, sizeof(ST_KeyRow));
	if(!pKeyRow) { DIE(); }
	if((unsigned)iSprNo > UINT16_MAX) {
		yyerror("スプライト番号が範囲外です。(%d)", iSprNo);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return NULL;	//y.tab.yの処理でYYERRORを行う。
	}
	if((nFrame < 1) || (nFrame > UINT16_MAX)) {
		yyerror("フレーム数が範囲外です。(%d)", nFrame);
		yynerrs++;	//呼び出し元(main)に知らせるために			//必要。YYERRORマクロ呼び出しでyynerrsは増やされないようだ。	←←←←←←←←←←■■■■重要■■■■
		return NULL;	//y.tab.yの処理でYYERRORを行う。
	}
	pKeyRow->iSprNo		= iSprNo;
	pKeyRow->nFrame		= nFrame;
	return pKeyRow;
}
/*---------------------------------------------------------------------------*/
//2パス目の処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static int Label_compar(LIST_ENTRY* _x, LIST_ENTRY* _y) {
	//当関数の処理は、ght_hash_table.h/cモジュールの動作に依存しています。
	//外部からght_hash_table_t.le_iteratorの順番を並び替えても、動作上問題有りません。
	ght_hash_entry_t* x = CONTAINING_RECORD(_x, ght_hash_entry_t, le_iterator);
	ght_hash_entry_t* y = CONTAINING_RECORD(_y, ght_hash_entry_t, le_iterator);
	return (*fnLabCmp)(x->key_data, y->key_data);
}
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
static void pass2(int bOptimize) {
	ght_iterator_t it;
	ST_Anm* pAnm;
	char* pAnmLab;
	//--- 最適化処理 ---
	{
		//最適化処理を行う。
		if(bOptimize) { optimize(); }
	}
	//アニメーションを名前の昇順にソートする。					//■■■注意：ght_hash_table_tの実装依存の処理です。■■■
	SortList(&ht_anm->le_iterator, Label_compar);
	//--- 2パス目で格納するフィールドを格納する ---
	{
		int iAnmNo = 0;	//アニメーション番号(1ベース)	ここでの初期値は0だが、プレインクリメントするので、1ベースになります。
		//各アニメーションについて…
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			//アニメーション番号(1ベース)を格納する。
			pAnm->iAnmNo		= ++iAnmNo;	//1ベースとするために、プレインクリメントする。
			if((unsigned)iAnmNo > UINT16_MAX) {
				yyerror("アニメーション数が多過ぎます。(%d)", iAnmNo);
				DIE();	//継続しても無駄なので終了する。
			}
		}
	}
	//--- アニメーションデータを作成する ---
	{
		int tmp;
		//各アニメーションについて…
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			ST_KeyRows* pKeyRows = pAnm->pKeyRows;
			int iKeyRow, nKeyRows = pKeyRows->nKeyRow;
			//アニメーションデータを作成するための、バッファを初期化する。
			obstack_init(&pAnm->o);
			//各キーフレームについて…
			for(iKeyRow = 0; iKeyRow < pKeyRows->nKeyRow; iKeyRow++) {
				ST_KeyRow* pKeyRow = pKeyRows->aKeyRow[iKeyRow];
				//最初のキーフレームならば…
				if(!pKeyRow->tKey) {
					//ST_AnmSeqを出力する。
					tmp = pAnm->tEnd;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 0, 2 ST_AnmSeq.tEnd
					tmp = pAnm->tRep;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 2, 2 ST_AnmSeq.tRep
					tmp = nKeyRows - 1;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 4, 2 ST_AnmSeq.nKey		//最初のキーフレームはヘッダ部分に出力するので、キーフレーム配列の要素数は(-1)して出力する。
					tmp = pKeyRow->iSprNo;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 6, 2 ST_AnmSeq.iVal
				//最初のキーフレーム以外ならば…
				} else {
					//ST_AnmKey(=ST_AnmSeq.TBL_Key[])を出力する。
					tmp = pKeyRow->tKey;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 0, 2 ST_AnmKey.tKey
					tmp = pKeyRow->iSprNo;	obstack_grow(&pAnm->o, &tmp, sizeof(uint16_t));		//+ 2, 2 ST_AnmKey.iVal
				}
			}
		}
	}
	//--- アドレスを設定する ---
	{
		int iWordAddr = 0;	//ワードアドレス
		//各アニメーションについて…
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			int nByteSize, nWordSize;
			//アニメーションデータのバイトサイズを求める。
			nByteSize = obstack_object_size(&pAnm->o);
			if(nByteSize % sizeof(int)) { DIE(); }	//アニメーションデータは(int)の倍数サイズであるはず。
			//アニメーションデータのワードサイズを求める。
			nWordSize = nByteSize / sizeof(int);
			//アニメーションデータのワードアドレスを格納する。
			pAnm->iWordAddr = iWordAddr;
			//ワードアドレスを進める。
			iWordAddr += nWordSize;
		}
		//全アニメーションデータワードサイズの合計を格納する。
		nTotalWordSize = iWordAddr;
	}
}
/*---------------------------------------------------------------------------*/
//最適化処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static void optimize() {
	/** no job **/
}
/*---------------------------------------------------------------------------*/
//出力処理
/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static void output(char* sBinOut) {
	ght_iterator_t it;
	ST_Anm* pAnm;
	char* pAnmLab;
	int* TBL_WordAddr/*[nAnmSeq+1]*/;	//アドレステーブル
	//アニメーションの数を取得しておく。
	const int nAnmSeq = ght_size(ht_anm);
	//--- ラベルを標準出力に出力する ---
	for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
	    pAnm;
	    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
		printf("#define AnmSeqNo_%s %d\n", pAnmLab, pAnm->iAnmNo);		//ラベルは1ベース
	}
	printf("#define AnmSeqNo_Max %d\n", nAnmSeq);					//ラベルの最大値	ラベルは1ベースなので、(ラベルの最大値==アニメーションの数) となる。
	//--- アドレステーブルを作成する ---
	{
		struct obstack o;
		obstack_init(&o);					//アドレステーブルを作成するための、バッファを初期化する。
		obstack_int_grow(&o, nAnmSeq + 1/*[0]自身の分*/);	//アドレステーブルの[0]に要素数を格納する。([0]自身も含む)
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			obstack_int_grow(&o, pAnm->iWordAddr);		//[1]～[nAnmSeq]
		}
		TBL_WordAddr = obstack_finish(&o);
		//この下でTBL_WordAddrを参照するので、'obstack_free(&o,NULL)'を行ってはいけない。
	}
	//--- データを出力する ---
	//バイナリ形式の場合…
	if(sBinOut) {
		FILE* fp = fopen(sBinOut, "wb");
		if(!fp) { error(EXIT_FAILURE, errno, "%s が作成できません。", sBinOut); }	//{{2016/09/21変更:die(～)で終了していた箇所を、error(EXIT_FAILURE,～)で終了するように変更しました。}}	//{{2016/09/28変更:error()の文字列の最後に余計な改行が付いていたのを削除しました。}}
		//アドレステーブルを出力する。
		fwrite(TBL_WordAddr, sizeof(int), nAnmSeq + 1/*[0]自身の分*/, fp);
		//アニメーションデータを出力する。
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			int* pAnmDat = obstack_base(&pAnm->o);
			int nByteSize, nWordSize;
			nByteSize = obstack_object_size(&pAnm->o);
			if(nByteSize % sizeof(int)) { DIE(); }
			nWordSize = nByteSize / sizeof(int);
			fwrite(pAnmDat, sizeof(int), nWordSize, fp);
		}
		fclose(fp);
	//テキスト形式の場合…
	} else {
		int i;
		//アドレステーブルを出力する。
		printf("const int TBL_AnmSeqNo[%d]={", nAnmSeq + 1/*[0]自身の分*/);
		for(i = 0; i < nAnmSeq + 1/*[0]自身の分*/; i++) {
			if(  i      ) { putchar(',' ); }
			if(!(i & 15)) { putchar('\n'); }
			printf("0x%08X", TBL_WordAddr[i]);
		}
		puts("};");
		//アニメーションデータを出力する。
		i = 0;
		printf("const int TBL_AnmSeq[%d]={", nTotalWordSize);
		for(pAnm = ght_first(ht_anm, &it, &pAnmLab);
		    pAnm;
		    pAnm = ght_next( ht_anm, &it, &pAnmLab)) {
			int* pAnmDat = obstack_base(&pAnm->o);
			int nByteSize, nWordSize, iAnmDat;
			nByteSize = obstack_object_size(&pAnm->o);
			if(nByteSize % sizeof(int)) { DIE(); }
			nWordSize = nByteSize / sizeof(int);
			for(iAnmDat = 0; iAnmDat < nWordSize; iAnmDat++) {
				if(  i      ) { putchar(',' ); }
				if(!(i & 15)) { putchar('\n'); }
				printf("0x%08X", pAnmDat[iAnmDat]);
				i++;
			}
		}
		puts("};");
	}
}
